package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 删除公告信息
 * 
 * @author puhui
 *
 */
public class announce_del extends XYZB implements API {
	public String parameter;//参数集合
	public String Description;//参数集合
	public String id;//文件id
	
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		parameter = MapUtil.getValue("parameter", data);
		
		id = MapUtil.getParameter(parameter, "id").trim();
		
		if ((!id.equals("")) && id.equals("code")) {
			parameter =  Current_announcement_id;
			parameter = MapUtil.killQuotes(parameter, "\"");//去掉双引号的Othercode
			data.put("parameter", parameter);
			return data;
		}
		if ((!id.equals("")) && id.equals("Othercode")) {
			parameter = Integer.valueOf(Current_id)-2+"";
			parameter = MapUtil.killQuotes(parameter, "\"");//去掉双引号的Othercode
			data.put("parameter", parameter);
			return data;
		}
		data.put("parameter", id);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, Object>  jsonAsMap = new HashMap<>();
		parameter = MapUtil.getValue("parameter", data);
		Response re = RequestDataUtils.Del_Token(data,Client_token, "/api/v1/announce/"+parameter);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("操作成功".equals(jp.getString("msg"))){
				
				//是否是线上环境
				if (!isProduct) {
					
					try {
						ResultSet rs_bankcard = this.selectFromDB(
								" xyu_room_files f ",
								" f.id = '" + Current_id + "' ");
						rs_bankcard.last();
						
						if (rs_bankcard.getRow()!=0){
							result = result && false;
							failReason = failReason + "xyu_room_files info in DB is wrong;";
						} else {
							Log.logInfo("xyu_room_files info in DB is correct;");
						}
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify xyu_room_files info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
